<template>
  <div>
    <div class="page-title">
      <h3>{{ 'Records history' | localization }}</h3>
    </div>

    <div class="history-chart">
      <canvas ref="canvas"></canvas>
    </div>

    <Loader v-if="loading" />

    <p v-else-if="!Object.keys(this.categories).length" class="center">
      {{ 'No categories yet' | localization }}
      <router-link to="/categories">
        {{ 'Add new category' | localization }}
      </router-link>
    </p>

    <p v-else-if="!records.length" class="center">
      {{ 'No records yet' | localization }}.
      <router-link to="/records">
        {{ 'Add new record' | localization }}
      </router-link>
    </p>

    <section v-else>
      <Table :records="items" :categories="categories" />

      <Paginate
        v-model="page"
        :page-count="this.totalPages"
        :click-handler="changePage"
        :prev-text="'<'"
        :next-text="'>'"
        :container-class="'pagination'"
      />

    </section>
  </div>
</template>

<script>

import Table from "@/components/history/Table";
import PaginatorMixin from '@/mixins/paginator';
import { Pie } from 'vue-chartjs';
import localization from "@/filters/localization";

export default {
  name: "History",
  mixins: [
    PaginatorMixin,
    Pie
  ],
  data: () => ({
    loading: true,
    records: [],
    categories: []
  }),
  async mounted() {
    try {
      this.records = await this.$store.dispatch('getRecords');
      this.categories = await this.$store.dispatch('getCategories');


      this.initPaginator(this.records.map( r => {
        return {
          ...r,
          categoryName: this.categories.find(c => c.id === r.categoryId).name
        };
      }));

      this.renderChart({
        labels: this.categories.map(c => c.name),
        datasets: [{
          label: localization('Outcomes'),
          data: this.categories.map(c => {
            return this.records.reduce((total, r) => {

              if (r.categoryId === c.id && 'outcome' === r.type) {
                return total += r.amount;
              }

              return total;
            }, 0);
          }),
          backgroundColor: [
            'rgba(255, 99, 132, 0.2)',
            'rgba(54, 162, 235, 0.2)',
            'rgba(255, 206, 86, 0.2)',
            'rgba(75, 192, 192, 0.2)',
            'rgba(153, 102, 255, 0.2)',
            'rgba(255, 159, 64, 0.2)'
          ],
          borderColor: [
            'rgba(255, 99, 132, 1)',
            'rgba(54, 162, 235, 1)',
            'rgba(255, 206, 86, 1)',
            'rgba(75, 192, 192, 1)',
            'rgba(153, 102, 255, 1)',
            'rgba(255, 159, 64, 1)'
          ],
          borderWidth: 1
        }]
      });

      this.loading = false;

    } catch (e) {
      console.log(e);
    }
  },
  components: {
    Table
  },
}
</script>

<style scoped>

</style>